#ifndef PILA_HPP
#define PILA_HPP

using namespace std;

#include <vector>

template <class T>
class Pila {

public:

  //Constructoras

  /* crea una pila buida*/
  Pila(){
    elems=vector<T>(MAX_SIZE);
    cur = 0;
  }

  /* crea una pila copia d'original*/
  Pila(const Pila& original){
    cur=original.cur;
    elems=vector<T>(original.elems);
//  elems=vector<T>(MAX_SIZE);
//  for (int i=0; i<cur; ++i) elems[i] = original.elems[i];
  }

  //Destructora
  ~Pila(){}

  //Modificadores 


  void push(const T &elemento) {
    elems[cur]=elemento;
    ++cur;
  }
  /* afegeix l'element x a la pila */


  /* la pila no és buida */
  void pop(){
    --cur;
  }
  /* elimina l'últim element afegit a la pila */

  //Cosultores 

  /* la pila no és buida */
  T top() const {
    return elems[cur-1];
  }
  /* retorna l'últim element afegit a la pila*/


  bool empty() const {
    return (cur==0);
  }
  /* ens retorna si la pila és buida o no */


  int size() const {
    return cur;
  }
  /* ens retorna la mida de la pila */

private:

  static const int MAX_SIZE = 1000;
  int cur; 
  vector<T> elems;

};

#endif
